<template>
  <Layout>
    <div>
      <Carousel v-bind:slideDatas="upcomingMovies.results" />
      <b-container class="cardContainer">
        <h2 class="head-info">
          <span class="head-title">Popular</span>
          <span class="subhead-title">Movies</span>
        </h2>
        <b-row>
          <b-col sm="2" v-for="movieList in popularMovies.results" :key="movieList.id">
            <CardMovie :movieList="movieList" />
          </b-col>
        </b-row>
        <h2 class="head-info">
          <span class="head-title">Now Playing</span>
          <span class="subhead-title">Movies</span>
        </h2>
        <b-row>
          <b-col sm="3" v-for="movieList in nowPlayingMovies.results" :key="movieList.id">
            <CardMovie :movieList="movieList" :large="true" />
          </b-col>
        </b-row>
        <h2 class="head-info">
          <span class="head-title">Top Rated</span>
          <span class="subhead-title">Movies</span>
        </h2>
        <b-row>
          <b-col sm="2" v-for="movieList in topRatedMovies.results" :key="movieList.id">
            <CardMovie :movieList="movieList" />
          </b-col>
        </b-row>
      </b-container>
    </div>
  </Layout>
</template>

<script>
import Layout from '../components/layout/DefaultLayout'
import Carousel from '../components/elements/Carousel'
import CardMovie from '../components/elements/CardMovie'
import axios from 'axios'
import { URL, SERVICES } from '../configs'

export default {
  name: 'Home',
  data () {
    return {
      popularMovies: [],
      topRatedMovies: [],
      latestMovies: [],
      nowPlayingMovies: [],
      upcomingMovies: []
    }
  },
  components: {
    Layout: Layout,
    Carousel: Carousel,
    CardMovie: CardMovie
  },
  created () {
    this.$_getPopularMovie()
    this.$_getTopRatedMovie()
    this.$_getNowPlaying()
    this.$_getUpcomingMovie()
  },
  // updated () {
  //   console.log('popular',this.popularMovies)
  //   console.log('toprated',this.topRatedMovies)
  //   console.log('upcoming',this.upcomingMovies)
  // },
  methods: {
    $_getPopularMovie () {
      axios({
        method: 'get',
        url: `${URL.BASE_URL}${SERVICES.MOVIE_POPULAR}?api_key=5c3b5f822f7052ad5aaf92e4c4560618&language=en-US&page=1`
      }).then(res => {
        this.popularMovies = {
          ...res.data,
          results: res.data.results.slice(0, 18)
        }
      })
    },
    $_getTopRatedMovie () {
      axios({
        method: 'get',
        url: `${URL.BASE_URL}${SERVICES.MOVIE_TOP_RATED}?api_key=5c3b5f822f7052ad5aaf92e4c4560618&language=en-US&page=1`
      }).then(res => {
        this.topRatedMovies = {
          ...res.data,
          results: res.data.results.slice(0, 6)
        }
      })
    },
    $_getNowPlaying () {
      axios({
        method: 'get',
        url: `${URL.BASE_URL}${SERVICES.MOVIE_NOW_PLAYING}?api_key=5c3b5f822f7052ad5aaf92e4c4560618&language=en-US&page=1`
      }).then(res => {
        console.log(res)
        this.nowPlayingMovies = {
          ...res.data,
          results: res.data.results.slice(0, 8)
        }
      })
    },
    $_getUpcomingMovie () {
      axios({
        method: 'get',
        url: `${URL.BASE_URL}${SERVICES.MOVIE_UPCOMING}?api_key=5c3b5f822f7052ad5aaf92e4c4560618&language=en-US&page=1`
      }).then(res => {
        this.upcomingMovies = {
          ...res.data,
          results: res.data.results.slice(0, 10)
        }
      })
    }
  }
}
</script>

<style scoped>
.head-info {
  border-bottom: 2px solid #20c997;
  padding: .5rem;
}
.head-title {
  color: #fff;
  font-weight: bolder;
}
.subhead-title {
  color: #fff;
  font-weight: lighter;
}
.cardContainer {
  margin-top: 1rem;
}
</style>
